
function Trim(const S: string): string;
var Ofs, Len: integer;
begin
  len := Length(S);
  while (Len>0) and (S[Len] in WhiteSpace) do
   dec(Len);
  Ofs := 1;
  while (Ofs<=Len) and (S[Ofs] in WhiteSpace) do
   Inc(Ofs);
  Trim := Copy(S, Ofs, 1 + Len - Ofs);
end ;


procedure Alinhar(Texto:String80;tipo:TAlinhamento);{Alinha o texto, sendo que o padro 
                                                      centralizar, o parmetro direita alinha a ...}
var POS_INICIAL: BYTE;
    ByteTemp:byte;
begin
  if tipo = Direita
  then POS_INICIAL:= lo(windmax)+2 - length(texto)
  else begin
       byteTemp:= (lo(windmax)+1-lo(WindMin))+ 2 - (length(Texto));
       POS_INICIAL:= byteTemp div 2;
       if Odd(byteTemp) then inc(POS_INICIAL);
       end;
  gotoxy(POS_INICIAL, whereY);
  write(texto);
end;

procedure AlinharLn(Texto:String80;tipo:TAlinhamento);
begin
   Alinhar(Texto,Tipo);
   writeln;
end;
{$ifdef ver70}
function UpCase(s: string): string;
var
  b:byte;
begin
  for b := 1 to length(s) do s[b] := system.upcase(s[b]);
  UpCase := s;
end;
{$endif}
procedure MessageBox(const titulo,texto:string);
begin
	SalvarTela(messageboxtela);
	Quadro(10,10,65,5,Simples,31);
	TituloQuadro(titulo);
	gotoxy(1,2);
	write(texto);
	readkey;
	RestaurarTela(messageboxtela);
end;

{---------------------------------------------------------------------------------------------- }
function Aviso(texto:String80):char;

var
salvarX,salvarY,winX1,winX2,winY1,WinY2:BYTE;
TextInicial:byte;
begin
        TextInicial:=TextAttr;
        SalvarX:=whereX;
        SalvarY:=whereY;
        WinX1:=lo(windmin)+1;
        WinY1:=hi(windmin)+1;
        WinX2:=lo(windmax)+1;
        WinY2:=hi(windmax)+1;
        Quadro(10,11,60,6,Simples,79);
        LimitarQuadro;
        Alinhar(texto,Centro);
        CursorOff;
        Aviso:=readkey;
    TextAttr:=TextInicial;
    CursorOn;
    window(lo(Windmin),HI(windMin),Lo(WindMax)+2,Hi(WindMax)+2);
    clrscr;
    window(WinX1,WinY1,WinX2,WinY2);
    gotoxy(SalvarX,SalvarY);
end;
{-------------------------------------------------------------------------------------------}

procedure ListarSubPastas;
var contador:integer;
    Pasta:SearchRec;
Begin
clrscr;
contador:=0;
Findfirst('*.*',anyfile,Pasta);
while (doserror = 0) and (contador < 25) do
      begin
      if (pasta.attr and directory >0)
      then if pasta.attr and volumeId = 0
           then if (Pasta.name <> '.') and (Pasta.name <>'..')
                then begin
                     WriteLn(Pasta.name);
                     Inc (Contador);
                     end;
      findNext(Pasta);
      end;{while}
end;


{-------------------------------------------------------------------------------------------}

procedure Ler_Real(var numero:real);
var Entrada:string;
        SalvarY,SalvarX:BYTE;
        erro:integer;

begin
        SalvarX:=whereX;
        SalvarY:=whereY;
        repeat
        gotoxy(SalvarX,SalvarY);
        clreol;
        readln(entrada);
        val(Entrada,numero,Erro);
        If erro <> 0
        then aviso('Nmero invlido.  Entre com outro nmero');
        until erro=0;

end;
{-------------------------------------------------------------------------------------------}
procedure ComandoDos(comando:string);

begin
   swapvectors;
   exec(GetEnv('comspec'),'/c '+ comando);
   swapvectors;
end;


{-------------------------------------------------------------------------------------------}
{$ifndef FPC}
procedure CursorOff;

var regs : registers;

begin
  FillChar (regs, SizeOf(regs), 0);  (* Initialize, a precaution *)
  {... find out the current cursor size (regs.ch, regs.cl) ...}
  regs.ah := $03;
  regs.bh := $00;    (* page 1, superfluous because of FillChar *)
  Intr ($10, regs);  (* ROM BIOS video driver interrupt *)
  {... turn off the cursor without changing its size ...}
  regs.ah := $01;                   (* Below are bits 76543210 *)
  regs.ch := regs.ch or $20;  (* Turn on bit 5; $20 = 00100000 *)
  Intr ($10, regs);
end;

procedure CursorOn;

var regs : registers;

begin
  FillChar (regs, SizeOf(regs), 0);  (* Initialize, a precaution *)
  {... find out the current cursor size (regs.ch, regs.cl) ...}
  regs.ah := $03;
  regs.bh := $00;    (* page 1, superfluous because of FillChar *)
  Intr ($10, regs);  (* ROM BIOS video driver interrupt *)
  {... turn off the cursor without changing its size ...}
  regs.ah := $01;                   (* Below are bits 76543210 *)
  regs.ch := regs.ch and $DF;  (* Turn off bit 5; $DF =not 00100000 *)
  Intr ($10, regs);
end;  

{$endif}
{-------------------------------------------------------------------------------------------}
procedure Quadro(X1,Y1,Largura,Altura:byte;Linha:TBorda;CorTela:byte);

var Hor,Vert,SupEsq,SupDir,InfEsq,InfDir:char;
    Contador:byte;

begin
        if (X1 + largura) > 81
        then largura:=81 -X1;
        if (Y1 + Altura) > 26
        then Altura:= 26 -Y1;
        TextAttr:=CorTela;
        window(X1,Y1,X1 + Largura-1,Y1 + Altura-1);
        clrscr;
        if Linha<>nenhuma
        then begin
             if Linha=Dupla
	         then begin
	              Hor:=#205;
	              Vert:=#186;
	              SupDir:=#187;
	              SupEsq:=#201;
	              InfDir:=#188;
	              InfEsq:=#200;
	              end
	         else begin
	              Hor:=#196;
	              Vert:=#179;
	              SupDir:=#191;
	              SupEsq:=#218;
	              InfDir:=#217;
	              InfEsq:=#192;
                  end;
             Write(SupEsq);
             for Contador:= 1 to (Largura -2) do
                Write(Hor);
             Write(SupDir);
             for Contador:= 1 to (Altura - 2) do
                begin
                gotoXy(1,WhereY);
                Write(vert);
                gotoXy(Largura,WhereY);
                Write(vert);
                end;
             Write(InfEsq);
             for Contador:= 1 to (Largura -2) do
                Write(Hor);
             WriteToCorner(InfDir);
             end;
        BordaUltimoQuadro:=Linha;
        QuadroExpandido:=true;
        GotoXy(1,1);
end;
{-------------------------------------------------------------------------------------------}
procedure LimitarQuadro;

begin
   if QuadroExpandido 
   then begin
   	    Window(lo(windMin)+2,hi(Windmin)+2,lo(windMax),hi(Windmax));
   	    QuadroExpandido:=False;
   	    end;
end;
{-------------------------------------------------------------------------------------------}
procedure ExpandirQuadro;

begin
  if not QuadroExpandido	
  then begin 
       window(Lo(windMin),hi(windMin),lo(windMax)+2,hi(Windmax)+2);
       QuadroExpandido:=True;
       end;
end;
{-------------------------------------------------------------------------------------------}
procedure TituloQuadro(const Titulo:string);

begin
  if not QuadroExpandido
  then window(Lo(windMin),hi(windMin),lo(windMax)+2,hi(Windmax)+2);	 
  If Titulo <> ''
  then  If BordaUltimoQuadro=Simples
        then Alinhar(#180#32+Titulo+#32#195,centro) 
        else if BordaUltimoQuadro = Dupla
             then Alinhar(#185#32+Titulo+#32#204,centro)
             else Alinhar(Titulo,centro);
  Window(lo(windMin)+2,hi(Windmin)+2,lo(windMax),hi(Windmax));
  QuadroExpandido:=false;  
end;
{-------------------------------------------------------------------------------------------}
procedure ApagarQuadro(CorBack:byte);

begin
  if not QuadroExpandido
  then window(Lo(windMin),hi(windMin),lo(windMax)+2,hi(Windmax)+2);
  TextAttr:=CorBack;
  clrscr;
end;
{-------------------------------------------------------------------------------------------}
procedure WriteToCorner(caracter:char);

begin
   {$ifdef ver1_0_6}
   gotoxy(winmaxx-winminx+1,winmaxy-winminy+1);
   Inc(WinMaxX);
   Write(caracter);
   Dec(WinMaxX);
   {$else}
   Inc(WindMax);
   GotoXy(lo(WindMax)-(lo(windMin)),hi(Windmax)+1 - hi(windMin));
   Write(caracter);
   Dec(WindMax);
   {$endif}
end;
{-------------------------------------------------------------------------------------------}
{$ifdef ver70}
function MonoCromatico : boolean;
  var regs : registers;
  begin
    FillChar (regs, SizeOf(regs), 0);
    regs.ah := $0F;
    Intr ($10, regs);
    MonoCromatico := (regs.al = 7);
  end;  
{$endif}
{-------------------------------------------------------------------------------------------}	
procedure SalvarTela(var Tela:TTela);

{$ifdef ver70}
var ScrSize : word;
begin
    Tela.Windmin:=Windmin;
    Tela.WindMax:=WindMax;
    Tela.X:=WhereX;
    Tela.Y:=WhereY;
    Tela.TextAttr:=TextAttr;
    {window(1,1,80,25);}
    {if MonoCromatico 
    then vidstart := SegB000 
    else vidstart := SegB800;}
    ScrSize := 2*80*25;{2*Succ(Lo(WindMax))*Succ(Hi(WindMax));}
    Move (Mem[vidstart:0000], Tela.CharInfo, ScrSize);
    {window(lo(tela.windmin)+1,hi(tela.windmin)+1,lo(tela.windMax)+1,hi(tela.windMax)+1);}
end;
{-------------------------------------------------------------------------------------------}
{$else}

begin
   Tela.Windmin:=Windmin;
   Tela.WindMax:=WindMax;
   Tela.X:=WhereX;
   Tela.Y:=WhereY;
   Tela.TextAttr:=TextAttr; 
   with Tela do
   begin
   if not Alocado
   then begin
   	    GetMem(CharInfo, (80+1)*(25+1)*SizeOf(TCharInfo));
   	    Alocado:=true;
   	    end;
   BufferSize.X:=80;
   BufferSize.Y:=25;
   BufferCoord.X:=0;
   BufferCoord.Y:=0;
   with Region do
     begin
     Top:=0;
     Bottom:=24;
     Left:=0;
     Right:=79;
     end;
   ReadConsoleOutput(GetStdHandle(STD_OUTPUT_HANDLE),CharInfo,BufferSize,BufferCoord,Region);
   end;
end;   

{$endif}

{-------------------------------------------------------------------------------------------}
procedure RestaurarTela({$ifdef ver1_0_4}const{$endif} Tela:TTela);

{$ifdef ver70}
var ScrSize : word;
begin
	window(1,1,80,25);
    ScrSize := 2*Succ(Lo(WindMax))*Succ(Hi(WindMax));
	Move (Tela.CharInfo, Mem[vidstart:0000], ScrSize);
	window(lo(tela.windmin)+1,hi(tela.windmin)+1,lo(tela.windMax)+1,hi(tela.windMax)+1);
	gotoxy(tela.x,tela.y);
	TextAttr:=tela.textattr;
end;

{$else}

begin
	window(1,1,80,25);
	{bug : 106 var param? }
	with Tela do
	  WriteConsoleOutput(GetStdHandle(STD_OUTPUT_HANDLE),CharInfo,BufferSize,BufferCoord,Region);
	window(lo(tela.windmin)+1,hi(tela.windmin)+1,lo(tela.windMax)+1,hi(tela.windMax)+1);
	gotoxy(tela.x,tela.y);
	TextAttr:=tela.textattr;
end;
{$endif}


{-----------------------------------------------------------------------------------------}

function Existe(const NomeArquivo:string; const Atributo:word):boolean;
var Arquivo:file;
    AtributoTemp:word;
begin
    existe:= false;
    Assign(arquivo,NomeArquivo);
    GetFAttr(Arquivo,AtributoTemp);
    If doserror = 0
    then existe:= (AtributoTemp and Atributo) > 0;
end;

{-------------------------------------------------------------------------------------------}
function PastaAtualCompleta:string;
var diretorio:string;
begin
GetDir(0,diretorio);
PastaAtualCompleta:=diretorio;
end;

{-------------------------------------------------------------------------------------------}
function PastaAtual:string;
var vPasta:string;
    Caracter:char;
    Posicao:byte;

begin
vPasta:=PastaAtualCompleta;
strTemp:='';
Posicao:=length(vPasta);
caracter:=vPasta[Posicao];
if Posicao <> 3
then begin
     while Caracter <> '\' do
       begin
       strTemp:=Caracter + strTemp;
       dec(Posicao);
       Caracter:=vPasta[Posicao];
       end;
     PastaAtual:=strTemp;
     end
else PastaAtual:='\';

end;
{-------------------------------------------------------------------------------------------}
function Maior(N1,N2:Longint):Longint;

begin
   If N1 > N2  then 
     Maior:=N1
   else Maior:=N2;
end;

function Menor(N1,n2:Longint):Longint;

begin
   If N1 < N2 
   then Menor:=N1
   else Menor:=N2;
end;

{-------------------------------------------------------------------------------------------}
function FloatToStr(NumeroReal:real):string;

var resultado:string;

begin
    str(NumeroReal,resultado);
    FloatToStr:=resultado;
end;

{-------------------------------------------------------------------------------------------}
function IntToStr(Inteiro:longint):string;

var Resultado:string;

begin
        str(Inteiro:0,Resultado);
        IntToStr:=Resultado;
end;
{-------------------------------------------------------------------------------------------}
function StrToInt(Str:string):longint;

var Resultado:Longint;
    Erro:integer;

begin
	val(Str,Resultado,Erro);
	if Erro = 0
	then StrToInt:=Resultado
	else StrToInt:=-99;
end;
{-------------------------------------------------------------------------------------------}
function Data:string;
var Dia,Mes,Ano,DiaSemana:word;
begin
   GetDate(Ano,Mes,Dia,DiaSemana);
   Data:=AcrescentarZero(Dia)+'/'+AcrescentarZero(Mes)+'/'+IntToStr(ano);
end;
{-------------------------------------------------------------------------------------------}
function Horario:string;

var Horas,Min,Seg,Cent:word;

begin
  GetTime(Horas,Min,Seg,Cent);
  Horario:= AcrescentarZero(Horas) + ':' + AcrescentarZero(Min) + ':' + AcrescentarZero(Seg);
end;

{-------------------------------------------------------------------------------------------}
function AcrescentarZero(Inteiro:longInt):string;

var s:string[5];

begin
   s:=IntToStr(Inteiro);
   If Length(s) = 1
   then AcrescentarZero:='0'+s
   else AcrescentarZero:=s;
end;
{-------------------------------------------------------------------------------------------}
function ReadESC:boolean;

begin
  If readKey=#27
  then ReadESC:=True
  else ReadESC:=false;
end;
{-------------------------------------------------------------------------------------------}
function Espaco(NumeroEspacos:byte):String;

var Str:String;
    
begin
        str:='';
        while NumeroEspacos > 0 do
          begin
          str:=str + ' ';
          dec(NumeroEspacos);
          end;
        Espaco:=str;
end;
{-------------------------------------------------------------------------------------------}


function GetTimeX:longint;

var horas,minuto,segundo,centesimo:word;
begin
   GetTime(horas,minuto,segundo,centesimo);
   GetTimeX:=centesimo + 100*segundo + 100*60*minuto + 100*60*60*horas;
end;
