unit lui;

interface
{$ifdef fpc}
  {$MODE TP}
{$endif}
{$ifndef ver70}
uses windows;
{$endif}

const kEnter=#13;
      kEsc=#27;
      kDelete=#83;
      kBackSpace=#8;
      kTab=#9;
      kHome=#71;
      kEnd=#79;
      kUp=#72;
      kDown=#80;
      kLeft=#75;
      kRight=#77;
      
{define cores : Fore/Back}      
      BrancoVermelho=79;

      Carriage:string=#13#10;

type String80=string[80];
     TBorda=(Simples,Dupla,Nenhuma);
     TAlinhamento=(Centro,Direita);
     
{$ifdef Virtualpascal}
  {$i vptype.inc}
{$endif}


{$ifdef ver70}
type TTela=record
     CharInfo:array[1..8000] of byte;
     X,Y,TextAttr:byte;
     WindMin,WindMax:word;
     end;
{$else}
type TTela=Record
     CharInfo:PChar_Info;
     BufferSize,BufferCoord:COORD; 
	 Region:SMALL_RECT;
	 X,Y,TextAttr:byte;
     WindMin,WindMax:word;
     Alocado:Boolean;
     end; 
{$endif}
            
var strTemp:String;
    byteTemp:byte;
    intTemp:LongInt;
    realTemp:real;

{------------------------------------PROCEDIMENTOS----------------------------------------}

procedure Alinhar(Texto:String80; tipo:TAlinhamento);

procedure AlinharLn(Texto:String80;tipo:TAlinhamento);
                                                      
procedure Ler_real(var numero:real);

procedure ComandoDos(comando:string);

procedure ListarSubPastas;

{$ifndef FPC}
Procedure CursorOn;

Procedure CursorOff;
{$endif}

{$ifdef Virtualpascal}
procedure intr(intno : byte;var regs : registers);

procedure Msdos(var regs : registers);
{$endif}

procedure WriteToCorner(caracter:char);

procedure Quadro(X1,Y1,Largura,Altura:byte;Linha:TBorda;CorTela:byte);

procedure LimitarQuadro;

procedure ExpandirQuadro;

procedure TituloQuadro(const Titulo:string);

procedure ApagarQuadro(CorBack:byte);

procedure RestaurarTela({$ifdef ver1_0_4}const{$endif} Tela:TTela);

procedure SalvarTela(var Tela:TTela);

procedure MessageBox(const titulo,texto:string);

   {----------------------------------------FUNES-----------------------------------------}

{$ifdef ver70}
function MonoCromatico : boolean;
{$endif}
function Aviso(texto:String80):char;

function PastaAtualCompleta:string;

function PastaAtual:string;

function Existe(const NomeArquivo:string;const Atributo:word):boolean;

function Maior(N1,n2:Longint):Longint;

function Menor(N1,n2:Longint):Longint;

function FloatToStr(NumeroReal:real):string;

function IntToStr(Inteiro:LongInt):string;

function StrToInt(Str:string):longint;

function Data:string;

function Horario:string;

function AcrescentarZero(Inteiro:longint):String;

function ReadESC:boolean;

function Espaco(NumeroEspacos:byte):String;

function ReadEdit(var parametro:string;TamanhoMax:byte):char;

function ReadEdit80(var parametro:string80;TamanhoMax:byte):char;

function GetTimeX:longint;

function Trim(const S:string):string;
{$ifdef ver70}
function UpCase(s: string): string;
{$endif}
{======================================================================================}
implementation

uses crt,dos;

Const WhiteSpace = [' ',#10,#13,#9];

{$ifdef Virtualpascal}
  {$i vpproc.inc}
{$endif}

var BordaUltimoQuadro:TBorda;
    QuadroExpandido:boolean;
    {$ifdef ver70}
    vidstart:word;
    {$endif}
    messageboxtela:ttela;
    

{$i lui.inc}
{$i readedit.inc}

begin
 {$ifdef ver70}
	if MonoCromatico
    then vidstart := SegB000
    else vidstart := SegB800;
 {$endif}
end.
